/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.importer.ImportAdminMenuInitializer");

dojo.require("rmps.importer.util");
dojo.require("rmps.core.util.IRmpsConstants");
dojo.require("rmps.app.ui.internal.util.DomainRegistryUtil");

dojo.requireLocalization("rmps.importer", "ImportCommonMessages");
var messages = dojo.i18n.getLocalization("rmps.importer", "ImportCommonMessages");

/*Add import menu items to the admin page */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminComponentMenu, "addExtendedCapabilityComponentMenuItems", {
	after: function() {
		var menu = dojox.lang.aspect.getContext().instance;
		var projectId = jazz.app.context.get().itemId;
		var dspDef = new dojo.Deferred();
		
		rmps.app.ui.internal.util.DomainRegistryUtil.isCurrentProjectDSP(
				dojo.hitch(this, function(isDsp, isSystem) {
					dspDef.callback();
					if (isDsp && !isSystem) {
					    menu.addTitle(messages.import_title);
						menu.addItemByArgs({
							label: messages.importMetamodels,
							href: rmps.core.util.IRmpsConstants.ADMIN_METAMODEL_IMPORT,
							icon: "rmps.importer/graphics/icons/ecoreImport.gif"
						});
						menu.addItemByArgs({
							label: messages.importProfiles,
							href: rmps.core.util.IRmpsConstants.ADMIN_PROFILE_IMPORT,
							icon: "rmps.importer/graphics/icons/profileImport.gif"
						});
						menu.addItemByArgs({
							label: messages.importStatus,
							href: rmps.core.util.IRmpsConstants.ADMIN_IMPORT_STATUS,
							icon: "rmps.importer/graphics/icons/importStatus.gif"
						});
					} else if ( isDsp && isSystem) {
					   //ignore
					} else {
					    menu.addTitle(messages.import_title);
						menu.addItemByArgs({
							label: messages.importDefinition,
							href: rmps.core.util.IRmpsConstants.ADMIN_IMPORT_VIEW_DEFINITION,
							icon: "rmps.importer/graphics/icons/importDefinition.gif"
						});
						menu.addItemByArgs({
							label: messages.requestImport,
							href: rmps.core.util.IRmpsConstants.ADMIN_IMPORT_REQUEST,
							icon: "rmps.importer/graphics/icons/requestImport.gif"
						});
						menu.addItemByArgs({
							label: messages.importStatus,
							href: rmps.core.util.IRmpsConstants.ADMIN_IMPORT_STATUS,
							icon: "rmps.importer/graphics/icons/importStatus.gif"
						});
					}
				})
		);		
		
	}
});

})();