/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.importer.Status");

dojo.require("rmps.core.Enum");
dojo.require("rmps.core.user.UserClient");

dojo.require("dojo.date.stamp");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.importer", "StatusMessages");

var messages = dojo.i18n.getLocalization("rmps.importer", "StatusMessages");

var STATUS_CURRENT_TIME = "http://jazz.net/xmlns/rmps/status/1.0/currentTime";
var STATUS_START_TIME = "http://jazz.net/xmlns/rmps/status/1.0/startTime";
var STATUS_SYNC_KEY = "http://jazz.net/xmlns/rmps/status/1.0/syncKey";
var STATUS_REQUESTER = "http://jazz.net/xmlns/rmps/status/1.0/requester";
var STATUS_REQUEST_ID = "http://jazz.net/xmlns/rmps/status/1.0/requestId";
var STATUS_REQUEST_TIME = "http://jazz.net/xmlns/rmps/status/1.0/requestTime";
var STATUS_STATE = "http://jazz.net/xmlns/rmps/status/1.0/state";

// error, completed
var STATUS_STOP_TIME = "http://jazz.net/xmlns/rmps/status/1.0/stopTime";

// error
var STATUS_EXCEPTION = "http://jazz.net/xmlns/rmps/status/1.0/exception";

// pending
var STATUS_POSITION = "http://jazz.net/xmlns/rmps/status/1.0/position";

// dropped
var STATUS_DROP_CAUSE = "http://jazz.net/xmlns/rmps/status/1.0/dropCause";

// validation
var VALIDATION_START_TIME = "http://jazz.net/xmlns/rmps/validation/1.0/startTime";
var VALIDATION_STOP_TIME = "http://jazz.net/xmlns/rmps/validation/1.0/stopTime";

// canceled
var CANCELLER = "http://jazz.net/xmlns/rmps/status/1.0/canceller";

// importer
var IMPORTER_PERMA_LINK_CONFLICT = "http://jazz.net/xmlns/rmps/importer/1.0/permaLinkConflict";
var IMPORTER_IMPORT_ENGINE_ERROR = "http://jazz.net/xmlns/rmps/importer/1.0/importEngineError";
var IMPORTER_NUMBER_OF_RESOURCES = "http://jazz.net/xmlns/rmps/importer/1.0/numberOfResources";
var IMPORTER_NUMBER_OF_ELEMENTS = "http://jazz.net/xmlns/rmps/importer/1.0/numberOfElements";
var IMPORTER_INVALID_PROJECT_PATH = "http://jazz.net/xmlns/rmps/importer/1.0/invalidProjectPath";
var IMPORTER_IGNORED_PATH = "http://jazz.net/xmlns/rmps/importer/1.0/ignoredPath";
var IMPORTER_DANGLING_REFERENCE = "http://jazz.net/xmlns/rmps/importer/1.0/danglingReference";
var IMPORTER_UNSET_PATH_MAP_VARIABLE = "http://jazz.net/xmlns/rmps/importer/1.0/unsetPathMapVariable";
var IMPORTER_NUMBER_OF_RESOURCES_DELETED = "http://jazz.net/xmlns/rmps/importer/1.0/numberOfResourcesDeleted";
var IMPORTER_STAGE = "http://jazz.net/xmlns/rmps/importer/1.0/stage";
var IMPORTER_ERROR_RESOURCE = "http://jazz.net/xmlns/rmps/importer/1.0/errorResource";
var IMPORTER_BASELINE_REQUEST_STATUS = "http://jazz.net/xmlns/rmps/importer/1.0/baselineRequestStatus";
var IMPORTER_MISSING_DOMAINS = "http://jazz.net/xmlns/rmps/importer/1.0/missingDomains";
var IMPORTER_PROFILES_EXIST = "http://jazz.net/xmlns/rmps/importer/1.0/profilesExist";

rmps.importer.StatusImporterStages = new rmps.core.Enum({
    ENGINE_WAIT: new rmps.core.EnumLiteral({name: messages.engineWait, value: "enginewait"}),
	DATA_TRANSFER: new rmps.core.EnumLiteral({name: messages.dataTransfer, value: "datatransfer"}),
	ANT_EXECUTION: new rmps.core.EnumLiteral({name: messages.antExecution, value: "antexecution"}),
	IMPORT_INIT: new rmps.core.EnumLiteral({name: messages.importInit, value: "importinitialization"}),
	DATA_PREPARATION: new rmps.core.EnumLiteral({name: messages.dataPreparation, value: "datapreparation"}),
	VALIDATION: new rmps.core.EnumLiteral({name: messages.validation, value: "validation"}),
	DATA_DELETE: new rmps.core.EnumLiteral({name: messages.dataDelete, value: "datadelete"}),
	IMPORT_COMPLETION: new rmps.core.EnumLiteral({name: messages.importCompletion, value: "importcompletion"}),
	SEND_EMAIL: new rmps.core.EnumLiteral({name: messages.sendEmail, value: "sendEmail"}),
	SAVE_IMPORT_DATA: new rmps.core.EnumLiteral({name: messages.saveImportData, value: "saveImportData"}),
	MIGRATE_COMMENTS_LINKS: new rmps.core.EnumLiteral({name: messages.migrateCommentsLinks, value: "migrateCommentsLinks"}),
	INITIALIZE_INTERNAL_DATA: new rmps.core.EnumLiteral({name: messages.initializeInternalData, value: "initializeInternalData"}),
	CREATE_SNAPSHOT: new rmps.core.EnumLiteral({name: messages.createSnapshot, value: "createSnapshot"}),
	CREATE_TEXT_INDEX: new rmps.core.EnumLiteral({name: messages.createTextIndex, value: "createTextIndex"}),
	COMMIT_CHANGESET: new rmps.core.EnumLiteral({name: messages.commitChangeset, value: "commitChangeset"}),
	CHECK_PREREQS: new rmps.core.EnumLiteral({name: messages.checkPrereqs, value: "checkPrereqs"}),
	CANCEL_CHANGESET: new rmps.core.EnumLiteral({name: messages.cancelChangeset, value: "cancelChangeset"}),
	CACHE_DIAGRAMS: new rmps.core.EnumLiteral({name: messages.cacheDiagrams, value: "cacheDiagrams"}),
	ASSOCIATE_DOMAINS: new rmps.core.EnumLiteral({name: messages.associateDomains, value: "associateDomains"}),
	RETRIEVE_DOMAIN_METADATA_RESOURCE: new rmps.core.EnumLiteral({name: messages.retrieveDomainMetaDataResources, value: "retrieveDomainMetaDataResources"}),
	UPDATE_DOMAIN_METADATA_RESOURCE: new rmps.core.EnumLiteral({name: messages.updateDomainMetaDataResources, value: "updateDomainMetaDataResources"}),
	PROCESS_REFERENCES: new rmps.core.EnumLiteral({name: messages.processReferences, value: "processReferences"}),
	CONVERT_RESOURCES: new rmps.core.EnumLiteral({name: messages.convertResources, value: "convertResources"}),
	CLEAN_CACHES: new rmps.core.EnumLiteral({name: messages.flushCaches, value: "flushCaches"}),
	FINALIZE_DATA_PREPARATION: new rmps.core.EnumLiteral({name: messages.finalizeDataPreparation, value: "finalizeDataPreparation"}),
	CLEAN_IMPORT_DATA: new rmps.core.EnumLiteral({name: messages.cleanImportData, value: "cleanImportData"}),
	DETECT_DELETABLE_RESOURCES: new rmps.core.EnumLiteral({name: messages.detectDeletableResources, value: "detectDeletableResources"}),
	WAITING_FOR_LOCK: new rmps.core.EnumLiteral({name: messages.waitingforlock, value: "waitingforlock"}),
	MIGRATE_PROJECT_FILES: new rmps.core.EnumLiteral({name: messages.migrateProjectFiles, value: "migrateProjectFiles"})});

rmps.importer.StatusStates = new rmps.core.Enum({
	UNKNOWN: new rmps.core.EnumLiteral({name: messages.unknown, value: "unknown", icon: dojo.moduleUrl("rmps.importer", "graphics/icons/obj16/state_unknown.gif")}),
	PENDING: new rmps.core.EnumLiteral({name: messages.pending, value: "pending", icon: dojo.moduleUrl("rmps.importer", "graphics/icons/obj16/state_pending.gif")}),
	IN_PROGRESS: new rmps.core.EnumLiteral({name: messages.inProgress, value: "inProgress", icon: dojo.moduleUrl("rmps.importer", "graphics/icons/obj16/state_inProgress.gif")}),
	ERROR: new rmps.core.EnumLiteral({name: messages.error, value: "error", icon: dojo.moduleUrl("rmps.importer", "graphics/icons/obj16/state_error.gif")}),
	DROPPED: new rmps.core.EnumLiteral({name: messages.dropped, value: "dropped", icon: dojo.moduleUrl("rmps.importer", "graphics/icons/obj16/state_dropped.gif")}),
	COMPLETED: new rmps.core.EnumLiteral({name: messages.completed, value: "completed", icon: dojo.moduleUrl("rmps.importer", "graphics/icons/obj16/state_completed.gif")}),
	WARNING: new rmps.core.EnumLiteral({name: messages.warning, value: "warning", icon: dojo.moduleUrl("rmps.importer", "graphics/icons/obj16/state_warning.gif")}),
	CANCELED: new rmps.core.EnumLiteral({name: messages.canceled, value: "canceled", icon: dojo.moduleUrl("rmps.importer", "graphics/icons/obj16/state_canceled.gif")}),
	CANCELING: new rmps.core.EnumLiteral({name: messages.canceling, value: "canceling", icon: dojo.moduleUrl("rmps.importer", "graphics/icons/obj16/state_canceling.gif")})
});

rmps.importer.BaselineRequestStatus = new rmps.core.Enum({
	SUCCESS: new rmps.core.EnumLiteral({value: "success", name: messages.baselineSuccess}),
	CONFLICT: new rmps.core.EnumLiteral({value: "conflict", name: messages.baselineConflict}),
	ERROR: new rmps.core.EnumLiteral({value: "error", name: messages.baselineError})
});

rmps.importer.StatusDropCauses = new rmps.core.Enum({
	IMPORT_ENGINE_UNRESPONSIVE: new rmps.core.EnumLiteral({name: messages.serviceUnresponsive, value: "serviceUnresponsive"})
});

var UserClient = rmps.core.user.UserClient;
var States = rmps.importer.StatusStates;
var DropCauses = rmps.importer.StatusDropCauses;
var ImporterStages = rmps.importer.StatusImporterStages;
var BaselineRequestStatus = rmps.importer.BaselineRequestStatus;

dojo.declare("rmps.importer.Status", null, {
	
	uri: null,
	
	currentTime: null, // Date
	startTime: null, // Date
	requestTime: null, // Date
	
	// importer
	syncKey: null, 
	requester: null,
	requestId: null,
	state: null,
	
	// pending
	position: null,
	
	// error, completed, dropped
	stopTime: null, // Date
	
	// error
	exception: null,
	
	// dropped
	dropCause: null,
	
	// canceled
	canceller: null,
	
	// validation
	validation_startTime: null,
	validation_stopTime: null,
	
	// importer
	importer_stage: null,
	importer_permaLinkConflicts: null,
	importer_importEngineErrors: null,
	importer_numberOfResources: null,
	importer_numberOfElements: null,
	importer_numberOfResourcesDeleted: null,
	importer_invalidProjectPaths: null, // []
	importer_ignoredPaths: null, // []
	importer_danglingReferences: null, // []
	importer_errorResources: null, // []
	importer_unsetPathMapVariables: null, // []
	importer_baselineRequestStatus: null,
	importer_missingDomains: null, //[]
	importer_profilesExist: null, //[]
	
	// private properties
	_requester: null,
	_canceller: null,
	
	/**
	 * Return a deferred for the requester of this status.
	 * 
	 * @return a Deferred for requester of this status
	 * @type dojo.Deferred
	 */
	getRequester: function() {
		if (this._requester && this._requester.uri == this.requester) {
			var deferred = new dojo.Deferred();
			setTimeout(dojo.hitch(this, function() {
				deferred.callback(this._requester);
			}), 0);
			return deferred;
		}
		var deferred = UserClient.getUser(this.requester);
		deferred.addCallback(dojo.hitch(this, function(user) {
			this._requester = user;
		}));
		return deferred;
	},
	
	/**
	 * Return a deferred for the canceller of this status.
	 * 
	 * @return a Deferred for canceller of this status
	 * @type dojo.Deferred
	 */
	getCanceller: function() {
		if (this._canceller && this._canceller.uri == this._canceller) {
			var deferred = new dojo.Deferred();
			setTimeout(dojo.hitch(this, function() {
				deferred.callback(this._canceller);
			}), 0);
			return deferred;
		}
		var deferred = UserClient.getUser(this.canceller);
		deferred.addCallback(dojo.hitch(this, function(user) {
			this._canceller = user;
		}));
		return deferred;
	},
	
	parseRdfJson: function(uri, rdf) {
		this.uri = uri;
		
		this.state = States.get(rdf[STATUS_STATE][0].value);
		this.syncKey = rdf[STATUS_SYNC_KEY][0].value;
		this.requester = rdf[STATUS_REQUESTER][0].value;
		this.requestId = rdf[STATUS_REQUEST_ID][0].value;
		this.requestTime = dojo.date.stamp.fromISOString(rdf[STATUS_REQUEST_TIME][0].value);
		
		if (rdf[STATUS_CURRENT_TIME]) {
			this.currentTime = dojo.date.stamp.fromISOString(rdf[STATUS_CURRENT_TIME][0].value);
		}
		
		if (rdf[STATUS_START_TIME]) {
			this.startTime = dojo.date.stamp.fromISOString(rdf[STATUS_START_TIME][0].value);
		}
		
		if (rdf[STATUS_STOP_TIME]) {
			this.stopTime = dojo.date.stamp.fromISOString(rdf[STATUS_STOP_TIME][0].value);
		}
		
		// error
		if (rdf[STATUS_EXCEPTION]) {
			this.exception = rdf[STATUS_EXCEPTION][0].value;
		}
		
		// pending
		if (rdf[STATUS_POSITION]) {
			this.position = parseInt(rdf[STATUS_POSITION][0].value);
		}
		
		// dropped
		if (rdf[STATUS_DROP_CAUSE]) {
			this.dropCause = DropCauses.get(rdf[STATUS_DROP_CAUSE][0].value);
		}
		
		// canceled
		if (rdf[CANCELLER]) {
			this.canceller = rdf[CANCELLER][0].value;
		}
		
		// validation
		if (rdf[VALIDATION_START_TIME]) {
			this.validation_startTime = dojo.date.stamp.fromISOString(rdf[VALIDATION_START_TIME][0].value);
		}
		
		if (rdf[VALIDATION_STOP_TIME]) {
			this.validation_stopTime = dojo.date.stamp.fromISOString(rdf[VALIDATION_STOP_TIME][0].value);
		}
		
		// importer
		function getArray(values) {
			var result = null;
			if (values) {
				result = [];
				for (var i = 0; i < values.length; ++i) {
					result.push(values[i].value);
				}
				result.sort();
			}
			return result;
		}
		
		// error
		this.importer_permaLinkConflicts = getArray(rdf[IMPORTER_PERMA_LINK_CONFLICT]);
		if (rdf[IMPORTER_IMPORT_ENGINE_ERROR]) {
			this.importer_importEngineErrors = rdf[IMPORTER_IMPORT_ENGINE_ERROR][0].value;
		}
		
		// !pending
		if (rdf[IMPORTER_NUMBER_OF_RESOURCES]) {
			var value = rdf[IMPORTER_NUMBER_OF_RESOURCES][0].value;
			this.importer_numberOfResources = parseInt(value ? value : 0, 10);
		}
		if (rdf[IMPORTER_NUMBER_OF_ELEMENTS]) {
			var value = rdf[IMPORTER_NUMBER_OF_ELEMENTS][0].value;
			this.importer_numberOfElements = parseInt(value ? value : 0, 10);
		}
		if (rdf[IMPORTER_NUMBER_OF_RESOURCES_DELETED]) {
			var value = rdf[IMPORTER_NUMBER_OF_RESOURCES_DELETED][0].value;
			this.importer_numberOfResourcesDeleted = parseInt(value ? value : 0, 10);
		}
		this.importer_invalidProjectPaths = getArray(rdf[IMPORTER_INVALID_PROJECT_PATH]);
		this.importer_ignoredPaths = getArray(rdf[IMPORTER_IGNORED_PATH]);
		this.importer_danglingReferences= getArray(rdf[IMPORTER_DANGLING_REFERENCE]);
		this.importer_errorResources = getArray(rdf[IMPORTER_ERROR_RESOURCE]);
		this.importer_unsetPathMapVariables = getArray(rdf[IMPORTER_UNSET_PATH_MAP_VARIABLE]);
		this.importer_missingDomains = getArray(rdf[IMPORTER_MISSING_DOMAINS]);
		this.importer_profilesExist = getArray(rdf[IMPORTER_PROFILES_EXIST]);
		
		if (rdf[IMPORTER_BASELINE_REQUEST_STATUS]) {
			this.importer_baselineRequestStatus = BaselineRequestStatus.get(rdf[IMPORTER_BASELINE_REQUEST_STATUS][0].value);
		}
		
		if (rdf[IMPORTER_STAGE]) {
			this.importer_stage = ImporterStages.get(rdf[IMPORTER_STAGE][0].value);
		}
	}
});
})();