/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.importer.pages.ImportPageController");

dojo.require("rmps.importer.ImportDefinitionEditorInput");
dojo.require("rmps.importer.ImportStatusEditorInput");
dojo.require("rmps.importer.RequestImportEditorInput");
dojo.require("rmps.importer.ProfileImportEditorInput");
dojo.require("rmps.app.ui.internal.pages.design.MetamodelImportEditorInput");

dojo.declare("rmps.importer.pages.ImportPageController", null, {
	
	// private properties
	_page: null,
	
	_defaultUrl: null,
	
	constructor: function(page) {
		this._page = page;
	},
	
	_default: function(args) {
		setTimeout(dojo.hitch(this, function() {
			window.location.href = this._page.getDefaultUri();
		}), 0);
	},
	
	status: function() {
		if(!this._importStatusEditorInput){
			this._importStatusEditorInput = new rmps.importer.ImportStatusEditorInput({projectId: jazz.app.context.get().itemId});
		}
		this._page.getPageHelper().openEditor(this._importStatusEditorInput);
	},
	
		
	viewDefinition: function(args) {
		if(!this._importDefinitionEditorInput){
			this._importDefinitionEditorInput = new rmps.importer.ImportDefinitionEditorInput({projectId: jazz.app.context.get().itemId});
		}
		this._page.getPageHelper().openEditor(this._importDefinitionEditorInput);
	},
	
	request: function(args) {
		if(!this._requestImportEditorInput){
			this._requestImportEditorInput = new rmps.importer.RequestImportEditorInput({projectId: jazz.app.context.get().itemId});	
		}
		this._page.getPageHelper().openEditor(this._requestImportEditorInput);		
	},
	
	importMetamodel: function(args) {
		if(!this._importMetamodelEditorInput) {
			this._importMetamodelEditorInput = rmps.app.ui.internal.pages.design.MetamodelImportEditorInput(args);	
		}
		this._page.getPageHelper().openEditor(this._importMetamodelEditorInput);		
	},
	
	importProfile: function(args) {
		if(!this._importProfileEditorInput) {
			this._importProfileEditorInput = rmps.importer.ProfileImportEditorInput(args);	
		}
		this._page.getPageHelper().openEditor(this._importProfileEditorInput);		
	}

});

})();
